#if !defined(_APIP_CHAR_P_COMMONS_H_)
#define _APIP_CHAR_P_COMMONS_H_

#ifdef __cplusplus
extern "C" {
#endif

#if !defined(_PARI_H_)
    #define _PARI_H_
    #include <pari.h>
#endif

#include "pairings.h"

#define USE_KARATSUBA           0
#define REPLACE_PARI_POLRED     1
#define POLRED(X, T, P)         _FpXQ_red(X, T, P)

//----------------------------------------------------------------------------
GEN _FpXQ_pow(GEN x, GEN n, GEN pol, GEN p);
GEN _FpXQ_pow_simple(GEN base, GEN power, GEN t, GEN p);
GEN _shallow_ZX_to_FpC(GEN fpx, int d);
GEN _shallow_FpC_to_ZX(GEN fpc, int vn);
GEN _FpM_FpXQ_mul(GEN M, GEN a, GEN Q, GEN p);
GEN _FpM_FpC_mul(GEN x, GEN y, GEN p);
GEN _FpM_mul(GEN x, GEN y, GEN p);
int _FpXQ_issquare(GEN x, GEN t, GEN p);
GEN _matid_FpM(unsigned long n);
//----------------------------------------------------------------------------
GEN _FpXQ_frobenius_map(GEN Q, GEN p);
int _FpXQ_compute_frobenius_powers(pairing_data_t* const pdata);
GEN _FpXQ_point_frobenius_power(pairing_data_t* const pdata, GEN P, int i);
GEN _FpXQ_frobenius_power(pairing_data_t* const pdata, GEN X, int i);
//----------------------------------------------------------------------------
GEN _FpXQ_red_2(GEN a, GEN t, GEN p);
GEN _FpXQ_red_2_safe(GEN a, GEN t, GEN p);
GEN _FpXQ_red_3(GEN a, GEN t, GEN p);
GEN _FpXQ_red_3_safe(GEN a, GEN t, GEN p);
GEN _FpXQ_red(GEN a, GEN t, GEN p);
//----------------------------------------------------------------------------
MAYBE_UNUSED INLINE GEN
apip_FpXQ_sqr(GEN x, GEN t, GEN p)
{
    #if REPLACE_PARI_POLRED == 1
        #if USE_KARATSUBA == 1
            GEN res = FpX_red(RgX_sqr(x), p);
            return POLRED(res, t, p);
        #else
            GEN res = FpX_red(ZX_sqr(x), p);
            return POLRED(res, t, p);
        #endif
    #else
        return FpXQ_sqr(x, t, p);
    #endif
}
//----------------------------------------------------------------------------
MAYBE_UNUSED INLINE GEN
apip_FpXQ_mul(GEN x, GEN y, GEN t, GEN p)
{
    #if REPLACE_PARI_POLRED == 1
        #if USE_KARATSUBA == 1
            GEN res = FpX_red(RgX_mul(x, y), p);
            return POLRED(res, t, p);
        #else
            GEN res = FpX_red(ZX_mul(x, y), p);
            return POLRED(res, t, p);
        #endif
    #else
        return FpXQ_mul(x, y, t, p);
    #endif
}
//----------------------------------------------------------------------------
MAYBE_UNUSED INLINE GEN
apip_FpX_rem(GEN x, GEN t, GEN p)
{
    #if REPLACE_PARI_POLRED == 1
        return POLRED(x, t, p);
    #else
        return FpX_rem(x, t, p);
    #endif
}
//----------------------------------------------------------------------------

#ifdef __cplusplus
}
#endif
#endif

